[@rxap/remote-method](../wiki/globals) / ProxyRemoteMethod

# Class: `abstract` ProxyRemoteMethod\<ReturnType, SourceParameter, TargetParameter\>

Defined in: [packages/angular/remote-method/src/lib/proxy.remote-method.ts:17](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/proxy.remote-method.ts#L17)

## Extends

- [`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod)\<`ReturnType`, `SourceParameter`\>

## Type Parameters

• **ReturnType** = `any`

• **SourceParameter** = `any`

• **TargetParameter** = `SourceParameter`

## Constructors

### new ProxyRemoteMethod()

> **new ProxyRemoteMethod**\<`ReturnType`, `SourceParameter`, `TargetParameter`\>(`remoteMethod`, `injector`, `metadata`): [`ProxyRemoteMethod`](../wiki/Class.ProxyRemoteMethod)\<`ReturnType`, `SourceParameter`, `TargetParameter`\>

Defined in: [packages/angular/remote-method/src/lib/proxy.remote-method.ts:20](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/proxy.remote-method.ts#L20)

#### Parameters

##### remoteMethod

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod)

##### injector

`null` | `Injector`

##### metadata

[`BaseRemoteMethodMetadata`](../wiki/Interface.BaseRemoteMethodMetadata) = `remoteMethod.metadata`

#### Returns

[`ProxyRemoteMethod`](../wiki/Class.ProxyRemoteMethod)\<`ReturnType`, `SourceParameter`, `TargetParameter`\>

#### Overrides

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`constructor`](../wiki/Class.BaseRemoteMethod#constructors)

## Properties

### \_\_id

> **\_\_id**: `string`

Defined in: [packages/angular/definition/src/lib/definition.ts:61](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L61)

**`Internal`**

unique internal id

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`__id`](../wiki/Class.BaseRemoteMethod#__id)

***

### \_initialised

> `protected` **\_initialised**: `boolean` = `false`

Defined in: [packages/angular/definition/src/lib/definition.ts:62](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L62)

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`_initialised`](../wiki/Class.BaseRemoteMethod#_initialised)

***

### destroyed$

> `readonly` **destroyed$**: `undefined` \| `Subject`\<`void`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:48](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L48)

Emits if the data source is destroyed

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`destroyed$`](../wiki/Class.BaseRemoteMethod#destroyed$)

***

### executed$

> **executed$**: `Subject`\<`ReturnType`\>

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:42](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/base.remote-method.ts#L42)

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`executed$`](../wiki/Class.BaseRemoteMethod#executed$)

***

### executionsInProgress$

> **executionsInProgress$**: `CounterSubject`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:44](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/base.remote-method.ts#L44)

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`executionsInProgress$`](../wiki/Class.BaseRemoteMethod#executionsinprogress$)

***

### initialised$

> `readonly` **initialised$**: `undefined` \| `Subject`\<`void`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:52](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L52)

Emits if the data source is initialised

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`initialised$`](../wiki/Class.BaseRemoteMethod#initialised$)

***

### injector

> `readonly` **injector**: `Injector`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:46](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/base.remote-method.ts#L46)

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`injector`](../wiki/Class.BaseRemoteMethod#injector-1)

***

### interceptors

> `readonly` **interceptors**: `undefined` \| `Set`\<`Subject`\<`any`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:53](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L53)

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`interceptors`](../wiki/Class.BaseRemoteMethod#interceptors)

***

### metadata

> **metadata**: [`BaseRemoteMethodMetadata`](../wiki/Interface.BaseRemoteMethodMetadata)

Defined in: [packages/angular/definition/src/lib/definition.ts:44](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L44)

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`metadata`](../wiki/Class.BaseRemoteMethod#metadata-1)

***

### destroyed$

> `readonly` `static` **destroyed$**: `Subject`\<`BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:41](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L41)

Emits when a new Definition instance is initialised

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`destroyed$`](../wiki/Class.BaseRemoteMethod#destroyed$-1)

***

### initialised$

> `readonly` `static` **initialised$**: `Subject`\<`BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:35](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L35)

Emits when a new Definition instance is initialised

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`initialised$`](../wiki/Class.BaseRemoteMethod#initialised$-1)

***

### instances

> `readonly` `static` **instances**: `Map`\<`string`, `BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:27](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L27)

A map of active Definition instances

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`instances`](../wiki/Class.BaseRemoteMethod#instances)

## Accessors

### id

#### Get Signature

> **get** **id**(): `string`

Defined in: [packages/angular/definition/src/lib/definition.ts:87](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L87)

##### Returns

`string`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`id`](../wiki/Class.BaseRemoteMethod#id)

## Methods

### \_call()

> `protected` **\_call**(`parameters`?): `Promise`\<`any`\>

Defined in: [packages/angular/remote-method/src/lib/proxy.remote-method.ts:33](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/proxy.remote-method.ts#L33)

#### Parameters

##### parameters?

`SourceParameter`

#### Returns

`Promise`\<`any`\>

#### Overrides

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`_call`](../wiki/Class.BaseRemoteMethod#_call)

***

### applyMetadata()

> **applyMetadata**(`partialMetadata`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:111](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L111)

#### Parameters

##### partialMetadata

`Partial`\<[`BaseRemoteMethodMetadata`](../wiki/Interface.BaseRemoteMethodMetadata)\>

#### Returns

`void`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`applyMetadata`](../wiki/Class.BaseRemoteMethod#applymetadata)

***

### call()

> **call**(`parameters`?): `Promise`\<`ReturnType`\>

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:76](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/base.remote-method.ts#L76)

#### Parameters

##### parameters?

`SourceParameter`

#### Returns

`Promise`\<`ReturnType`\>

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`call`](../wiki/Class.BaseRemoteMethod#call)

***

### ~~destroy()~~

> **destroy**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:118](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L118)

#### Returns

`void`

#### Deprecated

use ngOnDestroy instead

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`destroy`](../wiki/Class.BaseRemoteMethod#destroy)

***

### executed()

> **executed**(`result`): `void`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:86](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/base.remote-method.ts#L86)

#### Parameters

##### result

`ReturnType`

#### Returns

`void`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`executed`](../wiki/Class.BaseRemoteMethod#executed)

***

### getMetadata()

> **getMetadata**(): `null` \| [`BaseRemoteMethodMetadata`](../wiki/Interface.BaseRemoteMethodMetadata)

Defined in: [packages/angular/definition/src/lib/definition.ts:107](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L107)

#### Returns

`null` \| [`BaseRemoteMethodMetadata`](../wiki/Interface.BaseRemoteMethodMetadata)

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`getMetadata`](../wiki/Class.BaseRemoteMethod#getmetadata)

***

### init()

> **init**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:127](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L127)

#### Returns

`void`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`init`](../wiki/Class.BaseRemoteMethod#init)

***

### ngOnDestroy()

> **ngOnDestroy**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:122](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L122)

A callback method that performs custom clean-up, invoked immediately
before a directive, pipe, or service instance is destroyed.

#### Returns

`void`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`ngOnDestroy`](../wiki/Class.BaseRemoteMethod#ngondestroy)

***

### pauseRefresh()

> **pauseRefresh**(): `void`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:92](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/base.remote-method.ts#L92)

#### Returns

`void`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`pauseRefresh`](../wiki/Class.BaseRemoteMethod#pauserefresh)

***

### refresh()

> **refresh**(): `void`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:100](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/base.remote-method.ts#L100)

#### Returns

`void`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`refresh`](../wiki/Class.BaseRemoteMethod#refresh)

***

### resumeRefresh()

> **resumeRefresh**(): `void`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:96](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/base.remote-method.ts#L96)

#### Returns

`void`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`resumeRefresh`](../wiki/Class.BaseRemoteMethod#resumerefresh)

***

### transformParameters()

> `abstract` **transformParameters**(`parameters`?): `TargetParameter` \| `Promise`\<`TargetParameter`\>

Defined in: [packages/angular/remote-method/src/lib/proxy.remote-method.ts:31](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/remote-method/src/lib/proxy.remote-method.ts#L31)

#### Parameters

##### parameters?

`SourceParameter`

#### Returns

`TargetParameter` \| `Promise`\<`TargetParameter`\>

***

### add()

> `static` **add**(`definition`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:94](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L94)

#### Parameters

##### definition

`BaseDefinition`

#### Returns

`void`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`add`](../wiki/Class.BaseRemoteMethod#add)

***

### remove()

> `static` **remove**(`definition`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:102](https://gitlab.com/rxap/packages/-/blob/753c877fe1a5c2fcfa737310f6e99fd1371f9b4d/packages/angular/definition/src/lib/definition.ts#L102)

#### Parameters

##### definition

`BaseDefinition`

#### Returns

`void`

#### Inherited from

[`BaseRemoteMethod`](../wiki/Class.BaseRemoteMethod).[`remove`](../wiki/Class.BaseRemoteMethod#remove)
